# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::CDN
  module Models
    #
    # Geo filter of a CDN endpoint.
    #
    class GeoFilter

      include MsRestAzure

      # @return [String] Relative path applicable to geo filter. (e.g.
      # '/mypictures', '/mypicture/kitty.jpg', and etc.)
      attr_accessor :relative_path

      # @return [GeoFilterActions] Action of the geo filter. Possible values
      # include: 'Block', 'Allow'
      attr_accessor :action

      # @return [Array<String>] Two letter country codes of the geo filter.
      # (e.g. AU, MX, and etc.)
      attr_accessor :country_codes


      #
      # Mapper for GeoFilter class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'GeoFilter',
          type: {
            name: 'Composite',
            class_name: 'GeoFilter',
            model_properties: {
              relative_path: {
                required: true,
                serialized_name: 'relativePath',
                type: {
                  name: 'String'
                }
              },
              action: {
                required: true,
                serialized_name: 'action',
                type: {
                  name: 'Enum',
                  module: 'GeoFilterActions'
                }
              },
              country_codes: {
                required: true,
                serialized_name: 'countryCodes',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
